static const char *RcsId = "$Header: /users/chaize/newsvn/cvsroot/Instrumentation/DigitalDelayGenerator/src/DigitalDelayGenerator.cpp,v 1.6 2011-05-17 15:54:22 xavela Exp $";
//+=============================================================================
//
// file :         DigitalDelayGenerator.cpp
//
// description :  C++ source for the DigitalDelayGenerator and its commands. 
//                The class is derived from Device. It represents the
//                CORBA servant object which will be accessed from the
//                network. All commands which can be executed on the
//                DigitalDelayGenerator are implemented in this file.
//
// project :      TANGO Device Server
//
// $Author: xavela $
//
// $Revision: 1.6 $
//
// $Log: not supported by cvs2svn $
// Revision 1.5  2011/05/17 15:32:07  xavela
// Added units for pulse width attributes -> OK.
// TODO : clean up src.
//
// Revision 1.4  2011/05/01 22:30:28  xavela
// pulse width attributes for each channel added.
//
// Revision 1.3  2010/03/26 09:20:50  vince_soleil
// "Migration_Tango7_Part2"
//
// Revision 1.2  2009/02/25 17:42:24  xavela
// xavier :
// compil Linux -> OK
// TODO : retirer property sur type de com
// (RS232 trop lente).
//
// Revision 1.1  2009/01/21 13:04:56  stephle
// initial import
//
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================



//===================================================================
//
//	The following table gives the correspondence
//	between commands and method name.
//
//  Command name               |  Method name
//	----------------------------------------
//  State                      |  dev_state()
//  Status                     |  dev_status()
//  HardwareReset              |  hardware_reset()
//  ClearErrors                |  clear_errors()
//  ResetShots                 |  reset_shots()
//  SaveModuleConfiguration    |  save_module_configuration()
//  RecallModuleConfiguration  |  recall_module_configuration()
//
//===================================================================


#include <tango.h>
#include "Xstring.h"
#include "PogoHelper.h"
#include <DigitalDelayGenerator.h>
#include <DigitalDelayGeneratorClass.h>

//- The T560 module returns pulses values in seconds
//- ... in the device the unit choosen is the nano second
static const double SECONDS_TO_NANO_FATCOR = 1000000000.;
static const double SECONDS_TO_MICRO_FACTOR = 1000000.;
namespace DigitalDelayGenerator_ns
{

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::DigitalDelayGenerator(string &s)
// 
// description : 	constructor for simulated DigitalDelayGenerator
//
// in : - cl : Pointer to the DeviceClass object
//      - s : Device name 
//
//-----------------------------------------------------------------------------
DigitalDelayGenerator::DigitalDelayGenerator(Tango::DeviceClass *cl,string &s)
:Tango::Device_4Impl(cl,s.c_str())
{
	init_device();
}

DigitalDelayGenerator::DigitalDelayGenerator(Tango::DeviceClass *cl,const char *s)
:Tango::Device_4Impl(cl,s)
{
	init_device();
}

DigitalDelayGenerator::DigitalDelayGenerator(Tango::DeviceClass *cl,const char *s,const char *d)
:Tango::Device_4Impl(cl,s,d)
{
	init_device();
}
//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::delete_device()
// 
// description : 	will be called at device destruction or at init command.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::delete_device()
{
	//	Delete device's allocated object
	DELETE_SCALAR_ATTRIBUTE(attr_shotsCounter_read);
	//- CHANNEL A attributes :
	DELETE_SCALAR_ATTRIBUTE(attr_pulseDelayChannelA_read);
	DELETE_SCALAR_ATTRIBUTE(attr_pulseWidthChannelA_read);
  DELETE_SCALAR_ATTRIBUTE(attr_activateChannelA_read);
	//- CHANNEL B attributes :
	DELETE_SCALAR_ATTRIBUTE(attr_pulseDelayChannelB_read);
	DELETE_SCALAR_ATTRIBUTE(attr_pulseWidthChannelB_read);
	DELETE_SCALAR_ATTRIBUTE(attr_activateChannelB_read);
	//- CHANNEL C attributes :
	DELETE_SCALAR_ATTRIBUTE(attr_pulseDelayChannelC_read);
	DELETE_SCALAR_ATTRIBUTE(attr_pulseWidthChannelC_read);
	DELETE_SCALAR_ATTRIBUTE(attr_activateChannelC_read);
	//- CHANNEL D attributes :
	DELETE_SCALAR_ATTRIBUTE(attr_pulseDelayChannelD_read);
	DELETE_SCALAR_ATTRIBUTE(attr_pulseWidthChannelD_read);
	DELETE_SCALAR_ATTRIBUTE(attr_activateChannelD_read);

	//- Delete proxy :
	if( _communicationLink )
	{
		delete _communicationLink;
		_communicationLink = 0;
	}
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::init_device()
// 
// description : 	will be called at device initialization.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::init_device()
{
	INFO_STREAM << "DigitalDelayGenerator::DigitalDelayGenerator() create device " << device_name << endl;

	// Initialise variables to default values
	//--------------------------------------------
	_communicationLink = 0;
	_properties_missing = false;
	_error = false;

	CREATE_SCALAR_ATTRIBUTE(attr_shotsCounter_read);
	//- CHANNEL A attributes :
	CREATE_SCALAR_ATTRIBUTE(attr_pulseDelayChannelA_read);
	CREATE_SCALAR_ATTRIBUTE(attr_pulseWidthChannelA_read);
	CREATE_SCALAR_ATTRIBUTE(attr_activateChannelA_read, false);
	//- CHANNEL B attributes :
	CREATE_SCALAR_ATTRIBUTE(attr_pulseDelayChannelB_read);
	CREATE_SCALAR_ATTRIBUTE(attr_pulseWidthChannelB_read);
	CREATE_SCALAR_ATTRIBUTE(attr_activateChannelB_read, false);
	//- CHANNEL C attributes :
	CREATE_SCALAR_ATTRIBUTE(attr_pulseDelayChannelC_read);
	CREATE_SCALAR_ATTRIBUTE(attr_pulseWidthChannelC_read);
	CREATE_SCALAR_ATTRIBUTE(attr_activateChannelC_read, false);
	//- CHANNEL D attributes :
	CREATE_SCALAR_ATTRIBUTE(attr_pulseDelayChannelD_read);
	CREATE_SCALAR_ATTRIBUTE(attr_pulseWidthChannelD_read);
	CREATE_SCALAR_ATTRIBUTE(attr_activateChannelD_read, false);
	//- NOTE : the unit is the nanosecond for all pulse delay values !!!
	//- NOTE : the unit is the microsecond for all pulse width values !!!

	get_device_property();

	_init_done = false;

	INFO_STREAM << "Device up and ready!" << std::endl;
}


//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::get_device_property()
// 
// description : 	Read the device properties from database.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::get_device_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------
	communicationProxy = "noCommunication/DeviceProxy/Defined";

	//	Read device properties from database.(Automatic code generation)
	//------------------------------------------------------------------
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("CommunicationProxy"));

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_device()->get_property(dev_prop);
	Tango::DbDatum	def_prop, cl_prop;
	DigitalDelayGeneratorClass	*ds_class =
		(static_cast<DigitalDelayGeneratorClass *>(get_device_class()));
	int	i = -1;

	//	Try to initialize CommunicationProxy from class property
	cl_prop = ds_class->get_class_property(dev_prop[++i].name);
	if (cl_prop.is_empty()==false)	cl_prop  >>  communicationProxy;
	else {
		//	Try to initialize CommunicationProxy from default device value
		def_prop = ds_class->get_default_device_property(dev_prop[i].name);
		if (def_prop.is_empty()==false)	def_prop  >>  communicationProxy;
	}
	//	And try to extract CommunicationProxy value from database
	if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  communicationProxy;



	//	End of Automatic code generation
	//------------------------------------------------------------------
	Tango::DbData data_put;
	if (dev_prop[0].is_empty())
	{
		Tango::DbDatum	propert("CommunicationProxy");
		propert << communicationProxy;
		data_put.push_back(propert);
		_properties_missing = true;
		FATAL_STREAM << "Critical property <CommunicationProxy> is missing!" << std::endl;
	}

	//- apply default properties
	if (! data_put.empty())
		get_db_device()->put_property(data_put);

}
//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::always_executed_hook()
// 
// description : 	method always executed before any command is executed
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::always_executed_hook()
{
	//- Deffered init :
	if( !_init_done )
	{
		try
		{
			//- create proxy
			_communicationLink = new Tango::DeviceProxyHelper(communicationProxy,this);
			//- send default module configuration
			this->apply_default_configuration();
			//- module is initialised !
			_init_done = true;
			
			INFO_STREAM << "Proxy is created and device is configured!" << std::endl;
		}
		catch(...)
		{
			_communicationLink = 0;
			FATAL_STREAM << "Cannot build proxy on : \"" << communicationProxy << "\"" << std::endl;
		}
	}
}
//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::read_attr_hardware
// 
// description : 	Hardware acquisition for attributes.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::read_attr_hardware(vector<long> &attr_list)
{
	DEBUG_STREAM << "DigitalDelayGenerator::read_attr_hardware(vector<long> &attr_list) entering... "<< endl;
	//	Add your own code here
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::read_shotsCounter
// 
// description : 	Extract real attribute values for shotsCounter acquisition result.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::read_shotsCounter(Tango::Attribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::read_shotsCounter(Tango::Attribute &attr) entering... "<< endl;
	
	//- Prepare cmd : query shot(s) counter value
	std::string cmd_to_send("SH");
	//- Send cmd
	std::string nbShotsStr = this->write_read(cmd_to_send);
	//- update attribute value
	*attr_shotsCounter_read = XString<long>::convertFromString(nbShotsStr);
	//- set new value
	attr.set_value(attr_shotsCounter_read);
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::read_pulseDelayChannelA
// 
// description : 	Extract real attribute values for pulseDelayChannelA acquisition result.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::read_pulseDelayChannelA(Tango::Attribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::read_pulseDelayChannelA(Tango::Attribute &attr) entering... "<< endl;
	
	//- channel string
	std::string channel("A");
	//- read value
	this->read_pulseDelay(channel, *attr_pulseDelayChannelA_read);
	//- set new value
	attr.set_value(attr_pulseDelayChannelA_read);
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::write_pulseDelayChannelA
// 
// description : 	Write pulseDelayChannelA attribute values to hardware.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::write_pulseDelayChannelA(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::write_pulseDelayChannelA(Tango::WAttribute &attr) entering... "<< endl;

	//- get write part value
	attr.get_write_value(attr_pulseDelayChannelA_write);
	//- channel string
	std::string channel("A");
	//- write value on HW
	this->write_pulseDelay(channel, attr_pulseDelayChannelA_write);
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::read_pulseWidthChannelA
// 
// description : 	Extract real attribute values for pulseWidthChannelA acquisition result.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::read_pulseWidthChannelA(Tango::Attribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::read_pulseWidthChannelA(Tango::Attribute &attr) entering... "<< endl;
		
	//- channel string
	std::string channel("A");
	//- read value
	this->read_pulseWidth(channel, *attr_pulseWidthChannelA_read);
	//- set new value
	attr.set_value(attr_pulseWidthChannelA_read);
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::write_pulseWidthChannelA
// 
// description : 	Write pulseWidthChannelA attribute values to hardware.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::write_pulseWidthChannelA(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::write_pulseWidthChannelA(Tango::WAttribute &attr) entering... "<< endl;

	//- get write part value
	attr.get_write_value(attr_pulseWidthChannelA_write);
	//- channel string
	std::string channel("A");
	//- write value on HW
	this->write_pulseWidth(channel, attr_pulseWidthChannelA_write);
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::read_activateChannelA
// 
// description : 	Extract real attribute values for activateChannelA acquisition result.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::read_activateChannelA(Tango::Attribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::read_activateChannelA(Tango::Attribute &attr) entering... "<< endl;
	
	std::string channelStr("A");
	try
	{
		*attr_activateChannelA_read = this->isChannelActivated(channelStr);
		attr.set_value(attr_activateChannelA_read);
	}
	catch(Tango::DevFailed& )
	{
		attr.set_quality(Tango::ATTR_INVALID);
	}
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::write_activateChannelA
// 
// description : 	Write activateChannelA attribute values to hardware.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::write_activateChannelA(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::write_activateChannelA(Tango::WAttribute &attr) entering... "<< endl;
	
	std::string channelStr("A");
	
	attr.get_write_value(attr_activateChannelA_write);

	this->activateChannel(channelStr, attr_activateChannelA_write);
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::read_pulseDelayChannelB
// 
// description : 	Extract real attribute values for pulseDelayChannelB acquisition result.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::read_pulseDelayChannelB(Tango::Attribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::read_pulseDelayChannelB(Tango::Attribute &attr) entering... "<< endl;
	
	//- channel string
	std::string channel("B");
	//- read value
	this->read_pulseDelay(channel, *attr_pulseDelayChannelB_read);
	//- set new value
	attr.set_value(attr_pulseDelayChannelB_read);
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::write_pulseDelayChannelB
// 
// description : 	Write pulseDelayChannelB attribute values to hardware.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::write_pulseDelayChannelB(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::write_pulseDelayChannelB(Tango::WAttribute &attr) entering... "<< endl;

	//- get write part value
	attr.get_write_value(attr_pulseDelayChannelB_write);
	//- channel string
	std::string channel("B");
	//- write value on HW
	this->write_pulseDelay(channel, attr_pulseDelayChannelB_write);
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::read_pulseWidthChannelB
// 
// description : 	Extract real attribute values for pulseWidthChannelB acquisition result.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::read_pulseWidthChannelB(Tango::Attribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::read_pulseWidthChannelB(Tango::Attribute &attr) entering... "<< endl;
	
	//- channel string
	std::string channel("B");
	//- read value
	this->read_pulseWidth(channel, *attr_pulseWidthChannelB_read);
	//- set new value
	attr.set_value(attr_pulseWidthChannelB_read);
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::write_pulseWidthChannelB
// 
// description : 	Write pulseWidthChannelB attribute values to hardware.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::write_pulseWidthChannelB(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::write_pulseWidthChannelB(Tango::WAttribute &attr) entering... "<< endl;

	//- get write part value
	attr.get_write_value(attr_pulseWidthChannelB_write);
	//- channel string
	std::string channel("B");
	//- write value on HW
	this->write_pulseWidth(channel, attr_pulseWidthChannelB_write);
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::read_activateChannelB
// 
// description : 	Extract real attribute values for activateChannelB acquisition result.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::read_activateChannelB(Tango::Attribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::read_activateChannelB(Tango::Attribute &attr) entering... "<< endl;
	
	std::string channelStr("B");
	try
	{
		*attr_activateChannelB_read = this->isChannelActivated(channelStr);
		attr.set_value(attr_activateChannelB_read);
	}
	catch(Tango::DevFailed& )
	{
		attr.set_quality(Tango::ATTR_INVALID);
	}
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::write_activateChannelB
// 
// description : 	Write activateChannelB attribute values to hardware.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::write_activateChannelB(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::write_activateChannelB(Tango::WAttribute &attr) entering... "<< endl;
	
	std::string channelStr("B");
	
	attr.get_write_value(attr_activateChannelB_write);

	this->activateChannel(channelStr, attr_activateChannelB_write);
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::read_pulseDelayChannelC
// 
// description : 	Extract real attribute values for pulseDelayChannelC acquisition result.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::read_pulseDelayChannelC(Tango::Attribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::read_pulseDelayChannelC(Tango::Attribute &attr) entering... "<< endl;
	
	//- channel string
	std::string channel("C");
	//- read value
	this->read_pulseDelay(channel, *attr_pulseDelayChannelC_read);
	//- set new value
	attr.set_value(attr_pulseDelayChannelC_read);
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::write_pulseDelayChannelC
// 
// description : 	Write pulseDelayChannelC attribute values to hardware.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::write_pulseDelayChannelC(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::write_pulseDelayChannelC(Tango::WAttribute &attr) entering... "<< endl;

	//- get write part value
	attr.get_write_value(attr_pulseDelayChannelC_write);
	//- channel string
	std::string channel("C");
	//- write value on HW
	this->write_pulseDelay(channel, attr_pulseDelayChannelC_write);
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::read_pulseWidthChannelC
// 
// description : 	Extract real attribute values for pulseWidthChannelC acquisition result.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::read_pulseWidthChannelC(Tango::Attribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::read_pulseWidthChannelC(Tango::Attribute &attr) entering... "<< endl;
	
	//- channel string
	std::string channel("C");
	//- read value
	this->read_pulseWidth(channel, *attr_pulseWidthChannelC_read);
	//- set new value
	attr.set_value(attr_pulseWidthChannelC_read);
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::write_pulseWidthChannelC
// 
// description : 	Write pulseWidthChannelC attribute values to hardware.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::write_pulseWidthChannelC(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::write_pulseWidthChannelC(Tango::WAttribute &attr) entering... "<< endl;

	//- get write part value
	attr.get_write_value(attr_pulseWidthChannelC_write);
	//- channel string
	std::string channel("C");
	//- write value on HW
	this->write_pulseWidth(channel, attr_pulseWidthChannelC_write);
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::read_activateChannelC
// 
// description : 	Extract real attribute values for activateChannelC acquisition result.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::read_activateChannelC(Tango::Attribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::read_activateChannelC(Tango::Attribute &attr) entering... "<< endl;
	
	std::string channelStr("C");
	try
	{
		*attr_activateChannelC_read = this->isChannelActivated(channelStr);
		attr.set_value(attr_activateChannelC_read);
	}
	catch(Tango::DevFailed& )
	{
		attr.set_quality(Tango::ATTR_INVALID);
	}
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::write_activateChannelC
// 
// description : 	Write activateChannelC attribute values to hardware.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::write_activateChannelC(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::write_activateChannelC(Tango::WAttribute &attr) entering... "<< endl;
	
	std::string channelStr("C");
	
	attr.get_write_value(attr_activateChannelC_write);

	this->activateChannel(channelStr, attr_activateChannelC_write);
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::read_pulseDelayChannelD
// 
// description : 	Extract real attribute values for pulseDelayChannelD acquisition result.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::read_pulseDelayChannelD(Tango::Attribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::read_pulseDelayChannelD(Tango::Attribute &attr) entering... "<< endl;
	
	//- channel string
	std::string channel("D");
	//- read value
	this->read_pulseDelay(channel, *attr_pulseDelayChannelD_read);
	//- set new value
	attr.set_value(attr_pulseDelayChannelD_read);
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::write_pulseDelayChannelD
// 
// description : 	Write pulseDelayChannelD attribute values to hardware.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::write_pulseDelayChannelD(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::write_pulseDelayChannelD(Tango::WAttribute &attr) entering... "<< endl;

	//- get write part value
	attr.get_write_value(attr_pulseDelayChannelD_write);
	//- channel string
	std::string channel("D");
	//- write value on HW
	this->write_pulseDelay(channel, attr_pulseDelayChannelD_write);
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::read_pulseWidthChannelD
// 
// description : 	Extract real attribute values for pulseWidthChannelD acquisition result.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::read_pulseWidthChannelD(Tango::Attribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::read_pulseWidthChannelD(Tango::Attribute &attr) entering... "<< endl;
	
	//- channel string
	std::string channel("D");
	//- read value
	this->read_pulseWidth(channel, *attr_pulseWidthChannelD_read);
	//- set new value
	attr.set_value(attr_pulseWidthChannelD_read);
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::write_pulseWidthChannelD
// 
// description : 	Write pulseWidthChannelD attribute values to hardware.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::write_pulseWidthChannelD(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::write_pulseWidthChannelD(Tango::WAttribute &attr) entering... "<< endl;

	//- get write part value
	attr.get_write_value(attr_pulseWidthChannelD_write);
	//- channel string
	std::string channel("D");
	//- write value on HW
	this->write_pulseWidth(channel, attr_pulseWidthChannelD_write);
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::read_activateChannelD
// 
// description : 	Extract real attribute values for activateChannelD acquisition result.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::read_activateChannelD(Tango::Attribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::read_activateChannelD(Tango::Attribute &attr) entering... "<< endl;

	std::string channelStr("D");
	try
	{
		*attr_activateChannelD_read = this->isChannelActivated(channelStr);
		attr.set_value(attr_activateChannelD_read);
	}
	catch(Tango::DevFailed& )
	{
		attr.set_quality(Tango::ATTR_INVALID);
	}
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGenerator::write_activateChannelD
// 
// description : 	Write activateChannelD attribute values to hardware.
//
//-----------------------------------------------------------------------------
void DigitalDelayGenerator::write_activateChannelD(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "DigitalDelayGenerator::write_activateChannelD(Tango::WAttribute &attr) entering... "<< endl;
	
	std::string channelStr("D");
	
	attr.get_write_value(attr_activateChannelD_write);

	this->activateChannel(channelStr, attr_activateChannelD_write);
}



//+------------------------------------------------------------------
/**
 *	method:	DigitalDelayGenerator::dev_state
 *
 *	description:	method to execute "State"
 *	This command gets the device state (stored in its <i>device_state</i> data member) and returns it to the caller.
 *
 * @return	State Code
 *
 */
//+------------------------------------------------------------------
Tango::DevState DigitalDelayGenerator::dev_state()
{
	Tango::DevState	argout = DeviceImpl::dev_state();
	DEBUG_STREAM << "DigitalDelayGenerator::dev_state(): entering... !" << endl;

	//	Add your own code to control device here
	if( _properties_missing )
	{
		set_state(Tango::FAULT);
		return Tango::FAULT;
	}

	if( !_communicationLink )
	{
		set_state(Tango::FAULT);
		return Tango::FAULT;
	}

	//- ensure the comm is opened :
	Tango::DevState	ethernetState = Tango::UNKNOWN; 
	this->_communicationLink->command_out("State", ethernetState);
        if( ethernetState != Tango::ON )
	{
		set_state(Tango::FAULT);
		return Tango::FAULT;
	}

	if( _error )
	{
		set_state(Tango::ALARM);
		return Tango::ALARM;
	}

	//- prepare cmd :
	std::string state_cmd("ER");
	std::string response("");
	//- send cmd
	response = this->write_read(state_cmd);
	//- parse response
	if( response.find("None") != std::string::npos )
		argout = Tango::ON;
	else
		argout = Tango::ALARM;

	set_state(argout);
	return argout;
}

//+------------------------------------------------------------------
/**
 *	method:	DigitalDelayGenerator::dev_status
 *
 *	description:	method to execute "Status"
 *	This command gets the device status (stored in its <i>device_status</i> data member) and returns it to the caller.
 *
 * @return	Status description
 *
 */
//+------------------------------------------------------------------
Tango::ConstDevString DigitalDelayGenerator::dev_status()
{
	Tango::ConstDevString	argout = DeviceImpl::dev_status();
	DEBUG_STREAM << "DigitalDelayGenerator::dev_status(): entering... !" << endl;

	//	Add your own code to control device here
	if( _properties_missing )
		_status =  "Device properties are not set!";
	else if( !_communicationLink )
		_status =  "No communication link proxy!";
	else if( _communicationLink )
	{
		//- ensure the comm is opened :
		Tango::DevState	ethernetState = Tango::UNKNOWN; 
		this->_communicationLink->command_out("State", ethernetState);
                if( ethernetState != Tango::ON )
			_status = "No ethernet socket opened.";
	}
	else if( _error )
		_status = "Last operation reports an error!";
	else	//- no error : get device status
	{
		//- prepare cmd :
		std::string status_cmd("ST");
		_status = "";
		//- send cmd
		_status = this->write_read(status_cmd);
	}

	set_status(_status.c_str());
	return _status.c_str();
}

//+------------------------------------------------------------------
/**
 *	method:	DigitalDelayGenerator::hardware_reset
 *
 *	description:	method to execute "HardwareReset"
 *	Performs a hardware reset/restart of the T560 (equivalent to a power off/on cycle.
 *	NOTE : the reset takes about 4 seconds, after which the T560 will respond with the following string
 *	"Highland Thechnology T560 DDG <cr> <lf>"
 *	The last-saved setup will be installed.
 *
 *
 */
//+------------------------------------------------------------------
void DigitalDelayGenerator::hardware_reset()
{
	DEBUG_STREAM << "DigitalDelayGenerator::hardware_reset(): entering... !" << endl;

	//	Add your own code to control device here
	//- prepare cmd :
	std::string cmd("RSET");
	std::string response("");
	//- send cmd
	response = this->write_read(cmd);
	//- check device response
	if( response.find("Highland") == std::string::npos)
		Tango::Except::throw_exception(
			(const char*)"INVALID_DATA",
			(const char*)"Module reset command failed : no respone received from the module (wait 4 seconds!).",
			(const char*)"DigitalDelayGenerator::hardware_reset");
}

//+------------------------------------------------------------------
/**
 *	method:	DigitalDelayGenerator::abort_timing_cycle
 *
 *	description:	method to execute "AbortTimingCycle"
 *	Force End Of Delay, abort timing cycle.
 *
 *
 */
//+------------------------------------------------------------------
/*void DigitalDelayGenerator::abort_timing_cycle()
{
	DEBUG_STREAM << "DigitalDelayGenerator::abort_timing_cycle(): entering... !" << endl;

	//	Add your own code to control device here
	//- prepare cmd :
	std::string cmd("FE");
	std::string response("");
	//- send cmd
	response = this->write_read(cmd);
	//- check device response
	if( response.find("OK") == std::string::npos)
		Tango::Except::throw_exception(
			(const char*)"INVALID_DATA",
			(const char*)"Abort timing cycle failed.",
			(const char*)"DigitalDelayGenerator::abort_timing_cycle");

}
*/
//+------------------------------------------------------------------
/**
 *	method:	DigitalDelayGenerator::disable_trigger
 *
 *	description:	method to execute "DisableTrigger"
 *	Disable triggers.
 *
 *
 */
//+------------------------------------------------------------------
/*void DigitalDelayGenerator::disable_trigger()
{
	DEBUG_STREAM << "DigitalDelayGenerator::disable_trigger(): entering... !" << endl;

	//	Add your own code to control device here
	//- prepare cmd :
	std::string cmd("TR OF");
	std::string response("");
	//- send cmd
	response = this->write_read(cmd);
	//- check device response
	if( response.find("OK") == std::string::npos)
		Tango::Except::throw_exception(
			(const char*)"INVALID_DATA",
			(const char*)"Disable trigger command failed.",
			(const char*)"DigitalDelayGenerator::disable_trigger");
}
*/
//+------------------------------------------------------------------
/**
 *	method:	DigitalDelayGenerator::enable_trigger
 *
 *	description:	method to execute "EnableTrigger"
 *	Trigger on external rising edge.
 *
 *
 */
//+------------------------------------------------------------------
/*void DigitalDelayGenerator::enable_trigger()
{
	DEBUG_STREAM << "DigitalDelayGenerator::enable_trigger(): entering... !" << endl;

	//	Add your own code to control device here
	//- prepare cmd :
	std::string cmd("TR PO");		//- NOTE : enables RISING edge trigger
	std::string response("");
	//- send cmd
	response = this->write_read(cmd);
	//- check device response
	if( response.find("OK") == std::string::npos)
		Tango::Except::throw_exception(
			(const char*)"INVALID_DATA",
			(const char*)"Enable trigger command failed.",
			(const char*)"DigitalDelayGenerator::enable_trigger");
}
*/
//+------------------------------------------------------------------
/**
 *	method:	DigitalDelayGenerator::clear_errors
 *
 *	description:	method to execute "ClearErrors"
 *	Clear error flag.
 *
 *
 */
//+------------------------------------------------------------------
void DigitalDelayGenerator::clear_errors()
{
	DEBUG_STREAM << "DigitalDelayGenerator::clear_errors(): entering... !" << endl;

	//	Add your own code to control device here
	//- prepare cmd :
	std::string cmd("ER 0");
	std::string response("");
	//- send cmd
	response = this->write_read(cmd);
	//- check device response
	if( response.find("OK") == std::string::npos)
		Tango::Except::throw_exception(
			(const char*)"INVALID_DATA",
			(const char*)"Clear errors command failed.",
			(const char*)"DigitalDelayGenerator::clear_errors");
}

//+------------------------------------------------------------------
/**
 *	method:	DigitalDelayGenerator::reset_shots
 *
 *	description:	method to execute "ResetShots"
 *	Reset shot counter.
 *
 *
 */
//+------------------------------------------------------------------
void DigitalDelayGenerator::reset_shots()
{
	DEBUG_STREAM << "DigitalDelayGenerator::reset_shots(): entering... !" << endl;

	//	Add your own code to control device here
	std::string cmd("SH 0");
	std::string response("");
	//- send cmd
	response = this->write_read(cmd);
	//- check device response
	if( response.find("OK") == std::string::npos)
		Tango::Except::throw_exception(
			(const char*)"INVALID_DATA",
			(const char*)"Reset shots command failed.",
			(const char*)"DigitalDelayGenerator::reset_shots");
}

//+------------------------------------------------------------------
/**
 *	method:	DigitalDelayGenerator::apply_configuration
 *
 *	description:	method to execute "ApplyConfiguration"
 *	Send all channels configuration to the T560 Delay Generator.
 *
 *
 */
//+------------------------------------------------------------------
/*void DigitalDelayGenerator::apply_configuration()
{
	DEBUG_STREAM << "DigitalDelayGenerator::apply_configuration(): entering... !" << endl;

	//	Add your own code to control device here
	std::string cmd("IN");		//- NOTE : Apply all pending channel settings
	std::string response("");
	//- send cmd
	response = this->write_read(cmd);
	//- check device response
	if( response.find("OK") == std::string::npos)
		Tango::Except::throw_exception(
			(const char*)"INVALID_DATA",
			(const char*)"Apply configuration command failed.",
			(const char*)"DigitalDelayGenerator::apply_configuration");
}
*/

/************************************************************************/
/*																		*/	
/*						INTERNAL METHODS								*/
/*						----------------								*/	
/************************************************************************/

//+------------------------------------------------------------------
/**
 *	method:	DigitalDelayGenerator::read_pulseDelay
 *
 *	description:	method to execute "read_pulseDelay"
 *	Read the pulse delay set of the specified channel.
 *
 *	Param : in
 *		- the channel id (i.e. channel letter from A to D)
 *		- the channel pulse delay value (returned by reference)
 */
//+------------------------------------------------------------------
void DigitalDelayGenerator::read_pulseDelay(std::string channel, double& pulseDelay)
{
	//- Prepare cmd : delay CHANNEL query
	std::string cmd_to_send(channel + "DELAY");
	//- Send cmd
	std::string delayChannel_Str = this->write_read(cmd_to_send);
	//- update attribute value : value received from the T560 is in seconds
	pulseDelay = XString<double>::convertFromString(delayChannel_Str) * SECONDS_TO_NANO_FATCOR;
}

//+------------------------------------------------------------------
/**
 *	method:	DigitalDelayGenerator::write_pulseDelay
 *
 *	description:	method to execute "write_pulseDelay"
 *	Write the new pulse delay value on the specified channel.
 *
 *	Param : in
 *		- the channel id (i.e. channel letter from A to D)
 *		- the new value to set
 */
//+------------------------------------------------------------------
void DigitalDelayGenerator::write_pulseDelay(std::string channel, double pulseDelay)
{
	this->_error = false;

	std::string valStr = XString<double>::convertToString(pulseDelay);
	//- Prepare cmd : delay CHANNEL to set ( 'n' for nano second )
	std::string cmd_to_send(channel + "DELAY " + valStr + "n");
	//- Send cmd
	std::string returnedStatus = this->write_read(cmd_to_send);
	//- check device HW response
	if(returnedStatus.find("OK") == std::string::npos)
		this->_error = true;
}

//+------------------------------------------------------------------
/**
 *	method:	DigitalDelayGenerator::read_pulseWidth
 *
 *	description:	method to execute "read_pulseWidth"
 *	Read the pulse width set of the specified channel.
 *
 *	Param : in
 *		- the channel id (i.e. channel letter from A to D)
 *		- the channel pulse width value (returned by reference)
 */
//+------------------------------------------------------------------
void DigitalDelayGenerator::read_pulseWidth(std::string channel, double& pulseWidth)
{
	//- Prepare cmd : width CHANNEL query
	std::string cmd_to_send(channel + "WIDTH");
	//- Send cmd
	std::string widthChannel_Str = this->write_read(cmd_to_send);
	//- update attribute value
	pulseWidth = XString<double>::convertFromString(widthChannel_Str) * SECONDS_TO_MICRO_FACTOR;
}

//+------------------------------------------------------------------
/**
 *	method:	DigitalDelayGenerator::write_pulseWidth
 *
 *	description:	method to execute "write_pulseWidth"
 *	Write the new pulse width value on the specified channel.
 *
 *	Param : in
 *		- the channel id (i.e. channel letter from A to D)
 *		- the new value to set
 */
//+------------------------------------------------------------------
void DigitalDelayGenerator::write_pulseWidth(std::string channel, double pulseWidth)
{
	this->_error = false;

	std::string valStr = XString<double>::convertToString(pulseWidth);
	//- Prepare cmd : CHANNEL width to set
	std::string cmd_to_send(channel + "WIDTH " + valStr + "u");
	//- Send cmd
	std::string returnedStatus = this->write_read(cmd_to_send);
	//- check device HW response
	if(returnedStatus.find("OK") == std::string::npos)
		this->_error = true;
}

//+------------------------------------------------------------------
/**
 *	method:	DigitalDelayGenerator::isChannelActivated
 *
 *	description:	method to execute "isChannelActivated"
 *	Check if the specified channel is activated.
 *
 *	Param : in
 *		- the channel id (i.e. channel letter from A to D)
 */
//+------------------------------------------------------------------
bool DigitalDelayGenerator::isChannelActivated(std::string channel)
{
	this->_error = false;

	//- Prepare cmd : query channel A settings
	std::string cmd_to_send(channel + "SET");
	//- Send cmd
	std::string settingsCh_Str = this->write_read(cmd_to_send);
	//- parse the retruned string which is as this :
	//- -> "Ch A  POS  ON     Dly  00.000004500000  Wid  00.010000000000"
	//- find and extract the third setting which can be ON or OFF
	if(settingsCh_Str.find("ON") != std::string::npos)
		return true;
	else if(settingsCh_Str.find("OFF") != std::string::npos)
		return false;
	else
	{
		this->_error = true;
		Tango::Except::throw_exception(
			(const char*)"INVALID_DATA",
			(const char*)"Channel settings cannot be extracted : not expected string format received.",
			(const char*)"DigitalDelayGenerator::isChannelActivated");
	}
}

//+------------------------------------------------------------------
/**
 *	method:	DigitalDelayGenerator::activateChannel
 *
 *	description:	method to execute "activateChannel"
 *	Activate/Deactivate the specified channel.
 *
 *	Param : in
 *		- the channel id (i.e. channel letter from A to D)
 *		- value : TRUE activate the channel, FALSE deactivate it.
 */
//+------------------------------------------------------------------
void DigitalDelayGenerator::activateChannel(std::string channel, bool value)
{
	std::string activate("");

	this->_error = false;

	if(value)
		activate = "ON";
	else
		activate = "OFF";
	//- prepare cmd :
	std::string cmd_to_send(channel + "SET " + activate);
	//- send it :
	std::string response = this->write_read(cmd_to_send);
	//- check device response :
	if(response.find("OK") == std::string::npos)
		this->_error = true;
}

//+------------------------------------------------------------------
/**
 *	method:	DigitalDelayGenerator::write_read
 *
 *	description:	method to execute "write_read"
 *	Write command to the T560 module and return its response.
 *
 *	Param : in
 *		- string : command to send
			out
 *		- value : T560 module response.
 */
//+------------------------------------------------------------------
std::string DigitalDelayGenerator::write_read(std::string command_to_send)
{
	std::string response("");

	if(_communicationLink)
	{
		try
		{
                        this->_communicationLink->command_inout("WriteAndRead", command_to_send, response);

			INFO_STREAM << "Device response : " << response << std::endl;
		}
		catch(Tango::DevFailed& df)
		{
			Tango::Except::re_throw_exception(df, \
			  static_cast<const char*>("UNKNOWN_ERROR"), \
			  static_cast<const char*>("write_read command failed" ), \
			  static_cast<const char*>("DigitalDelayGenerator::write_read")); \
		}
		catch(...)
		{
			throw;
		}
	}

	return response;
}

//+------------------------------------------------------------------
/**
 *	method:	DigitalDelayGenerator::apply_default_configuration
 *
 *	description:	method to execute "apply_default_configuration"
 *	Configure the T560 module as follow :
 *
 *		- Set all channels polarity to POSITIVE
 *		- Trigger input is terminated at 50 ohms
 *		- Autoinstall is cancelled 
 *		- Trigger external LEVEL set to 2.5V
 *		- Trigger external POLARITY set to POSITIVE
 */
//+------------------------------------------------------------------
void DigitalDelayGenerator::apply_default_configuration()
{
	//- No verbose
	this->write_read("VE 0");
	//- Set all channels polarity to POSITIVE 
	this->write_read("AS PO");
	this->write_read("BS PO");
	this->write_read("CS PO");
	this->write_read("DS PO");
	//- Set all channels width to 10µs
	this->write_read("QW 10u");
	//- Autoinstall is enabled : i.e. all changes are applied !
	this->write_read("AU 1");
	//- Trigger input is terminated at 50 ohms
	this->write_read("TR TE");
	//- Trigger external LEVEL set to 2.5V
	this->write_read("TL 2.0");
	//- Trigger external POLARITY set to POSITIVE
	this->write_read("TR PO");
}




//+------------------------------------------------------------------
/**
 *	method:	DigitalDelayGenerator::save_module_configuration
 *
 *	description:	method to execute "SaveModuleConfiguration"
 *	Save the T560 module configuration in its intrenal flash memory.
 *	This configuartion is applied after a reset.
 *
 *
 */
//+------------------------------------------------------------------
void DigitalDelayGenerator::save_module_configuration()
{
  //DEBUG_STREAM << "DigitalDelayGenerator::save_module_configuration(): entering... !" << endl;

	//- prepare cmd :
	std::string cmd("SA");
	std::string response("");
	//- send cmd
	response = this->write_read(cmd);
	//- check device response
	if( response.find("OK") == std::string::npos)
		Tango::Except::throw_exception(
			(const char*)"UNKNOWN_ERROR",
			(const char*)"Failed to save module configuration.",
			(const char*)"DigitalDelayGenerator::save_module_configuration");
}

//+------------------------------------------------------------------
/**
 *	method:	DigitalDelayGenerator::recall_module_configuration
 *
 *	description:	method to execute "RecallModuleConfiguration"
 *	Reapply the previous module configuration. No need to do a reset.
 *
 *
 */
//+------------------------------------------------------------------
void DigitalDelayGenerator::recall_module_configuration()
{
	DEBUG_STREAM << "DigitalDelayGenerator::recall_module_configuration(): entering... !" << endl;

	//- prepare cmd :
	std::string cmd("RE");
	std::string response("");
	//- send cmd
	response = this->write_read(cmd);
	//- check device response
	if( response.find("OK") == std::string::npos)
		Tango::Except::throw_exception(
			(const char*)"UNKNOWN_ERROR",
			(const char*)"Failed to restore module configuration.",
			(const char*)"DigitalDelayGenerator::recall_module_configuration");
}



}	//	namespace
